#include <iostream>

#include <stdsoap2.h>

#include <arc/notify.h>
#include <arc/job.h>
#include <arc/job_jsdl.h>
#include <arc/job_xrsl.h>

int main() {

	//SetNotifyLevel(DEBUG);
	const char* job_str;

/*
	job_str = " \
<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n \
<jsdl:JobDefinition\n \
  xmlns=\"http://www.example.org/\"\n \
  xmlns:jsdl=\"http://schemas.ggf.org/jsdl/2005/06/jsdl\"\n \
  xmlns:jsdl-posix=\"http://schemas.ggf.org/jsdl/2005/06/jsdl-posix\"\n \
  xmlns:jsdl-arc=\"http://www.nordugrid.org/ws/schemas/jsdl-arc\"\n \
  xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n \
 <jsdl:JobDescription>\n \
  <jsdl:JobIdentification>\n \
   <jsdl:JobName>Test</jsdl:JobName>\n \
  </jsdl:JobIdentification>\n \
  <jsdl:JobDescription>\n \
   <jsdl:Application>\n \
    <jsdl-posix:POSIXApplication>\n \
     <jsdl-posix:Executable>\n \
      /bin/echo \
     </jsdl-posix:Executable>\n \
    </jsdl-posix:POSIXApplication>\n \
   </jsdl:Application>\n \
  </jsdl:JobDescription>\n \
  <jsdl:JobDescription>\n \
   <jsdl:Application>\n \
    <jsdl-posix:POSIXApplication>\n \
     <jsdl-posix:Executable>\n \
      /bin/true\n \
     </jsdl-posix:Executable>\n \
    </jsdl-posix:POSIXApplication>\n \
   </jsdl:Application>\n \
  </jsdl:JobDescription>\n \
  <jsdl:JobDescription>\n \
   <jsdl:Application>\n \
    <jsdl-posix:POSIXApplication>\n \
     <jsdl-posix:Executable>\n \
      /bin/false\n \
     </jsdl-posix:Executable>\n \
    </jsdl-posix:POSIXApplication>\n \
   </jsdl:Application>\n \
  </jsdl:JobDescription>\n \
  <jsdl:Application>\n \
   <jsdl-posix:POSIXApplication>\n \
    <jsdl-posix:Argument>Test</jsdl-posix:Argument>\n \
    <jsdl-posix:Input>input.dat</jsdl-posix:Input>\n \
    <jsdl-posix:Output>output.dat</jsdl-posix:Output>\n \
   </jsdl-posix:POSIXApplication>\n \
  </jsdl:Application>\n \
 </jsdl:JobDescription>\n \
</jsdl:JobDefinition>";
	try {
		std::cout<<" *** Initial JSDL document:  "<<std::endl;
		std::cout<<job_str<<std::endl<<std::endl<<std::endl;
		JobRequestJSDL job(job_str);
		std::cout<<" *** Parsed JSDL job description: "<<std::endl;
		std::cout<<job<<std::endl<<std::endl<<std::endl;
		JobRequestJSDL job_(*((JobRequest*)&job));
		std::cout<<" *** JSDL job description passed through general interface: "<<std::endl;
		std::cout<<job_<<std::endl<<std::endl<<std::endl;
		JobRequestXRSL job__(job);
		std::cout<<" *** xRSL job description generated from parsed JSDL "<<std::endl;
		std::cout<<job__<<std::endl;
	} catch(ARCLibError e) {
		std::cout << e.what() << std::endl;
		return 1;
	};
*/
/*
	job_str = "&(executable=/bin/echo)(|(arguments=arg1)(arguments=arg2))";
    try {
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job_str<<std::endl;
        JobRequestXRSL job(job_str);
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job<<std::endl;
        JobRequestXRSL job_(*((JobRequest*)&job));
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job_<<std::endl;
    } catch(ARCLibError e) {
        std::cout << e.what() << std::endl;
        return 1;
    };
*/
/*
	job_str = "&(\"clientsoftware\" = \"nordugrid-0.5.34\" )(\"hostname\" = \"sepeli.csc.fi\")(\"walltime\" = \"600\" )(\"cputime\" = \"600\" )(\"executables\" = \"hellogrid.sh\")(\"outputfiles\" = (\"gridlog\" \"\" ) (\"hello.err\" \"\" ) (\"hello.out\" \"\" ))(\"inputfiles\" = (\"hellogrid.sh\" \"118.2947316455\" ) )(\"clientxrsl\" = \"&(\"\"executable\"\" = \"\"hellogrid.sh\"\" )(\"\"jobname\"\" = \"\"hellogrid\"\" )(\"\"stdout\"\" = \"\"hello.out\"\" )(\"\"stderr\"\" = \"\"hello.err\"\" )(\"\"gmlog\"\" = \"\"gridlog\"\")(\"\"cputime\"\" = \"\"10\"\" )(\"\"memory\"\" = \"\"32\"\" )(\"\"disk\"\" = \"\"1\"\" )\" )(\"savestate\"= \"yes\" )(\"action\" = \"request\" )(\"queue\" = \"mgrid\" )(\"executable\" = \"hellogrid.sh\" )(\"jobname\" = \"hellogrid\" )(\"stdout\" = \"hello.out\" )(\"stderr\" = \"hello.err\" )(\"gmlog\" = \"gridlog\" )(\"memory\" = \"32\" )(\"disk\" = \"1\" )";
    try {
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job_str<<std::endl;
        JobRequestXRSL job(job_str);
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job<<std::endl;
        JobRequestXRSL job_(*((JobRequest*)&job));
        std::cout<<" ------------------------------------ "<<std::endl;
        std::cout<<job_<<std::endl;
    } catch(ARCLibError e) {
        std::cout<<" ************************************ "<<std::endl;
        std::cout << e.what() << std::endl;
        return 1;
    };
*/


	job_str = " \
<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n \
<jsdl:JobDefinition\n \
    xmlns=\"http://www.example.org/\"\n \
    xmlns:jsdl=\"http://schemas.ggf.org/jsdl/2005/06/jsdl\"\n \
    xmlns:jsdl-posix=\"http://schemas.ggf.org/jsdl/2005/06/jsdl-posix\"\n \
    xmlns:jsdl-arc=\"http://www.nordugrid.org/ws/schemas/jsdl-arc\"\n \
    xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">\n \
<jsdl:JobDescription>\n \
    <jsdl:JobIdentification>\n \
        <jsdl:JobName>My Test JSDL job</jsdl:JobName>\n \
        <jsdl:Description>\n \
          This is me first attempt at submitting an JSDL job to ARC GM\n \
        </jsdl:Description>\n \
    </jsdl:JobIdentification>\n \
    <jsdl:Application>\n \
        <jsdl:ApplicationName>echo</jsdl:ApplicationName>\n \
        <jsdl-posix:POSIXApplication>\n \
            <jsdl-posix:Executable> /bin/echo <jsdl-posix:Executable>\n \
      <jsdl-posix:Input>input.dat</jsdl-posix:Input>\n \
          <jsdl-posix:Output>output.dat</jsdl-posix:Output>\n \
            <jsdl-posix:Argument>Hello world</jsdl-posix:Argument>\n \
        </jsdl-posix:Application>\n \
    </jsdl:Application>\n \
    <jsdl:DataStaging>\n \
       <jsdl:FileName>input.dat</jsdl:FileName>\n \
       <jsdl:Source>\n \
         <jsdl:URI>http://www.nordugrid.org/Welcome.html</jsdl:URI>\n \
       </jsdl:Source>\n \
       <jsdl:CreationFlag>jsdl:overwrite</jsdl:CreationFlag>\n \
       <jsdl:DeleteOnTermination>true</jsdl:DeleteOnTermination>\n \
    </jsdl:DataStaging>\n \
    <jsdl:DataStaging>\n \
       <jsdl:FileName>output.dat</jsdl:FileName>\n \
       <jsdl:Target>\n \
          <jsdl:URI>gsiftp://hathi.hep.lu.se/public/jsdl-test.dat</jsdl:URI>\n \
       </jsdl:Target>\n \
       <jsdl:DeleteOnTermination>true</jsdl:DeleteOnTermination>\n \
    </jsdl:DataStaging>\n \
</jsdl:JobDescription>\n \
</jsdl:JobDefinition>";


	job_str = " \
<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n \
<jsdl:JobDefinition\n \
    xmlns:jsdl=\"http://schemas.ggf.org/jsdl/2005/06/jsdl\"\n \
    xmlns:jsdl-posix=\"http://schemas.ggf.org/jsdl/2005/06/jsdl-posix\">\n \
 <jsdl:JobDescription>\n \
    <jsdl:JobIdentification>\n \
        <jsdl:JobName>My Test JSDL job</jsdl:JobName>\n \
        <jsdl:Description>\n \
          This is me first attempt at submitting an JSDL job to ARC GM\n \
        </jsdl:Description>\n \
    </jsdl:JobIdentification>\n \
    <jsdl:Application>\n \
        <jsdl:ApplicationName>echo</jsdl:ApplicationName>\n \
        <jsdl-posix:POSIXApplication>\n \
          <jsdl-posix:Executable> /bin/echo </jsdl-posix:Executable>\n \
          <jsdl-posix:Input>input.dat</jsdl-posix:Input>\n \
          <jsdl-posix:Output>output.dat</jsdl-posix:Output>\n \
          <jsdl-posix:Argument>Hello world</jsdl-posix:Argument>\n \
        </jsdl-posix:POSIXApplication>\n \
    </jsdl:Application>\n \
    <jsdl:DataStaging>\n \
       <jsdl:FileName>input.dat</jsdl:FileName>\n \
       <jsdl:Source>\n \
         <jsdl:URI>http://www.nordugrid.org/Welcome.html</jsdl:URI>\n \
       </jsdl:Source>\n \
       <jsdl:CreationFlag>overwrite</jsdl:CreationFlag>\n \
       <jsdl:DeleteOnTermination>true</jsdl:DeleteOnTermination>\n \
    </jsdl:DataStaging>\n \
    <jsdl:DataStaging>\n \
       <jsdl:FileName>output.dat</jsdl:FileName>\n \
       <jsdl:Target>\n \
          <jsdl:URI>gsiftp://hathi.hep.lu.se/public/jsdl-test.dat</jsdl:URI>\n \
       </jsdl:Target>\n \
       <jsdl:DeleteOnTermination>true</jsdl:DeleteOnTermination>\n \
    </jsdl:DataStaging>\n \
 </jsdl:JobDescription>\n \
</jsdl:JobDefinition>";
    try {
        std::cout<<" *** Initial JSDL document:  "<<std::endl;
        std::cout<<job_str<<std::endl<<std::endl<<std::endl;
        JobRequestJSDL job(job_str);
        std::cout<<" *** Parsed JSDL job description: "<<std::endl;
        std::cout<<job<<std::endl<<std::endl<<std::endl;
        JobRequestJSDL job_(*((JobRequest*)&job));
        std::cout<<" *** JSDL job description passed through general interface: "<<std::endl;
        std::cout<<job_<<std::endl<<std::endl<<std::endl;
        JobRequestXRSL job__(job);
        std::cout<<" *** xRSL job description generated from parsed JSDL "<<std::endl;
        std::cout<<job__<<std::endl;
    } catch(ARCLibError e) {
        std::cout << e.what() << std::endl;
        return 1;
    };


	return 0;
}
